/////////////////////////////////////////////////////////////////
//
// pbo.h
// (c)2003 by Ales Mlakar aka JaZzBrE (jazzbre@xubl.com)
//
/////////////////////////////////////////////////////////////////

#ifndef __PBO_H__
#define __PBO_H__

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "wcxhead.h"

//#define __STL_NO_NAMESPACES
#include <vector>
#include <string>
using namespace std;

/////////////////////////////////////////////////////////////////
//
// PboEntry
//
/////////////////////////////////////////////////////////////////

class    PboEntry
{
public:
   PboEntry();

public:
   int      Read(FILE *f);
   int      Write(FILE *f);

public:
   string   filename;
   int      unknown[4];
   int      size;
};

/////////////////////////////////////////////////////////////////
//
// PboPack
//
/////////////////////////////////////////////////////////////////

class	   PboPack
{
public:
	PboPack();
	virtual ~PboPack();

public:
   virtual  int   Open(const char *name);   
   virtual  int   Close();

   virtual  int   ReadHeader();

   virtual  int   ExtractFile(PboEntry *ent, const char *outname);
   virtual  int   CompressFiles(const vector<string> &fnames, const char *path, const char *outname);
public:
   // typedefs 
   typedef  vector<PboEntry*> PboEntryVector;
   // vars
   PboEntryVector             Entry;
   string                     CurPath;
   FILE                       *pPBOFile;
   int                        curfile;
   int                        curprocessfile;
   string                     CurName;
   tProcessDataProc           m_ProcessDataProc;
};

#endif

/////////////////////////////////////////////////////////////////
//
//
//
/////////////////////////////////////////////////////////////////
